// vim: set syntax=opencl:

#define IMSTRIDE	47

inline static
float4 transform_pixel(float4 a4)
{
	float4 r4;
	int is_null;
	float C, v;

	C = a4.x - a4.y;

	is_null = isless(C, 0.5f);


	v = select(a4.z, 0.0f, is_null);

	r4.x = a4.x;
	r4.y = 255.0f*v;
	r4.z = a4.y;
	r4.w = 0.0f;

	return r4;
}


__kernel void transform(__global const uchar4* restrict in,
                        __global uchar4* restrict out)
{
	int gix = get_global_id(0);
	int giy = get_global_id(1);

	float4 pix;
	uchar4 pix_in;

	pix_in = in[gix + giy*(IMSTRIDE/sizeof(*in))];
	pix = convert_float4(pix_in);
	pix = transform_pixel(pix);
	out[gix + giy*(IMSTRIDE/sizeof(*out))] = convert_uchar4_sat(pix);
}
